package de.sheepstar.globalWrapper.api;

import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.entities.Guild;

import java.sql.ResultSet;

/********************************
 * @author Mathias Wagner
 * Created 18.12.20
 ********************************/

public class ShopManager {

    LevelManager levelManager;
    Guild guild;

    public ShopManager(LevelManager lm) {
        this.levelManager = lm;
        this.guild = lm.getGuild();
    }

    public void buyItem(String price, String item, boolean checkItemOwnership) {
        if (checkItemOwnership && hasItem(item)) return;
        if (Integer.parseInt(levelManager.getLevel()) >= Integer.parseInt(price)) {
            if (item.equals("premium")) {
                Main.getGlobalManager().setPremium(guild);
                return;
            }
            MySQL.update("INSERT INTO items_buyed (guildID, item) VALUES (?, ?)", guild.getId(), item);
            levelManager.removeLevel(price);
        }
    }

    public boolean hasItem(String item) {
        if (item.equals("premium")) {
            return Main.getGlobalManager().hasPremium(guild);
        }
        ResultSet rs = MySQL.getResult("SELECT * FROM items_buyed WHERE guildID=? AND item=?", guild.getId(), item);
        try {
            while (rs.next()) {
                return true;
            }
        } catch (Exception ignored) {}
        return false;
    }

    public int getItemCount(String item) {
        ResultSet rs = MySQL.getResult("SELECT * FROM items_buyed WHERE guildID=? AND item=?", guild.getId(), item);
        int count=0;
        try {
            while (rs.next()) {
                count++;
            }
        } catch (Exception ignored) {}
        return count;
    }


}
