package de.sheepstar.globalWrapper.api;

import de.sheepstar.globalWrapper.api.messagebuilder.MessageBuilder;
import de.sheepstar.globalWrapper.api.messagebuilder.MessageType;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.sql.ResultSet;

/********************************
 * @author Mathias Wagner
 * Created 17.12.20
 ********************************/

public class ValidationCheck {

    public boolean validate(GuildMessageReceivedEvent e) {
        GlobalManager gm = Main.getGlobalManager();
        if (e.getAuthor().isBot()) return false;

        if (SheepManager.BETA_INSTANCE) {
            if (e.getMessage().getContentRaw().toLowerCase().startsWith("st!")) return false;
        } else {
            if (e.getMessage().getContentRaw().toLowerCase().startsWith("s!")) return false;
        }

        if (e.getMessage().getContentRaw().startsWith("=")) {
            e.getMessage().addReaction(Main.getInstance().getEmotesByName("Sstar_cross", false).get(0)).queue();
            return false;
        }

        try {
            e.getMessage().delete().queue();
        } catch (Exception err) { return false; }

        if (!(e.getChannel().getSlowmode() > 4)) {
            new MessageBuilder(MessageType.RED_MESSAGE)
                    .setDescription("This channel requires a slow mode of at least 5 seconds for writing")
                    .send(e.getChannel());
            return false;
        }

        if (gm.isBanned(e.getGuild())) {
            new MessageBuilder(MessageType.RED_MESSAGE)
                    .setDescription("This server is banned from Global Chat. You can write an Unban request under [this Link](https://discord.gg/jbne9JTJtU).")
                    .send(e.getChannel());
            return false;
        }

        if (gm.isGuildUserBanned(e.getGuild(), e.getAuthor().getId())) {
            new MessageBuilder(MessageType.RED_MESSAGE)
                    .setDescription(e.getAuthor().getAsMention() + ", you are banned from the global chat on this Server. Please contact the server owner if you think, this is an error.")
                    .send(e.getChannel());
            return false;
        }

        if (gm.isGlobalUserBanned(e.getAuthor().getId())) {
            new MessageBuilder(MessageType.RED_MESSAGE)
                    .setDescription(e.getAuthor().getAsMention() + ", you are banned from Global Chat. You can write an Unban request under [this Link](https://discord.gg/jbne9JTJtU).")
                    .send(e.getChannel());
            return false;
        }

        // Check if Message Contains Ads
        String msg = e.getMessage().getContentRaw().toLowerCase();
        if ((msg.contains("http://") ||
                msg.contains("https://") ||
                msg.contains("www.")) && !e.getAuthor().getId().equals("357214370188492802")) {
            new MessageBuilder(MessageType.RED_MESSAGE)
                    .setTitle("Stop it!")
                    .setDescription(e.getAuthor().getAsMention() + ", you are not allowed to send Links here.")
                    .send(e.getChannel());
            return false;
        }

        if (isBlocked(e.getMessage().getContentRaw()) || isServerBlocked(e.getGuild().getId(), e.getMessage().getContentRaw())) {
            new MessageBuilder(MessageType.RED_MESSAGE)
                    .setTitle("Stop it!")
                    .setDescription(e.getAuthor().getAsMention() + ", you are not allowed to offend here.")
                    .send(e.getChannel());
            return false;
        }
        return true;
    }

    public boolean isServerBlocked(String guildID, String msgContent) {
        msgContent = msgContent.replace(" ", "");
        ResultSet rs = MySQL.getResult("SELECT * FROM sword_blacklist WHERE guildID=? AND ? LIKE concat('%', word, '%');", guildID, msgContent);
        try { while (rs.next()) {return true;} } catch (Exception err) {}
        return false;
    }

    public boolean isBlocked(String msgContent) {
        msgContent = msgContent.replace(" ", "");
        ResultSet rs = MySQL.getResult("SELECT * FROM word_blacklist WHERE ? LIKE concat('%', word, '%');", msgContent);
        try { while (rs.next()) {return true;} } catch (Exception err) {}
        return false;
    }

}
