package de.sheepstar.globalWrapper.api.sql;

import de.sheepstar.globalWrapper.api.SheepManager;
import de.sheepstar.globalWrapper.core.Main;

import java.sql.*;

public class MySQL {

    public static String host = Main.getSheepManager().getSQLParam(SqlParam.HOSTNAME);
    public static String database = Main.getSheepManager().getSQLParam(SqlParam.DATABASE);
    public static String username = Main.getSheepManager().getSQLParam(SqlParam.USERNAME);
    public static String password = Main.getSheepManager().getSQLParam(SqlParam.PASSWORD);
    public static Connection con;

    public static void connect() {
        if (!isConnected()) {
            try {
                SheepManager.sendConsoleMessage("Connecting to " + host + " with user " + username + " to database " + database);
                con = DriverManager.getConnection("jdbc:mysql://" + host + "/" + database + "?useSSL=false&autoReconnect=true&useUnicode=yes&characterEncoding=UTF-8&allowPublicKeyRetrieval=true", username, password);
                SheepManager.sendConsoleMessage("MySQL Connection established");
            } catch (SQLException throwables) {
                throwables.printStackTrace();
            }
        }
    }

    public static void disconnect() {
        if (isConnected()) {
            try {
                con.close();
                con = null;
                SheepManager.sendConsoleMessage("MySQL Connection closed");
            } catch (SQLException throwables) {
                throwables.printStackTrace();
            }
        }
    }

    public static boolean isConnected() {
        return (con != null);
    }

    public static void update(String qry, String... param) {
        try {
            PreparedStatement ps = con.prepareStatement(qry);
            int number = 1;
            for (String current : param) {
                ps.setString(number, current);
                number++;
            }
            ps.executeUpdate();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
    }

    public static ResultSet getResult(String qry, String... param) {
        try {
            PreparedStatement ps = con.prepareStatement(qry);
            int number = 1;
            for (String current : param) {
                ps.setString(number, current);
                number++;
            }

            return ps.executeQuery();
        } catch (SQLException throwables) {
            throwables.printStackTrace();
        }
        return null;
    }

}
