package de.sheepstar.globalWrapper.api.sql;

import de.sheepstar.globalWrapper.core.Main;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class TableGenerator {
    public static void run() {
        // Generiere Server-Bantabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS log" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`senderID` VARCHAR(255) NOT NULL , " +
                "`date` TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6), " +
                "`message` VARCHAR(255) NOT NULL , " +
                "`language` VARCHAR(255) NOT NULL , " +
                "`roomID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Designtabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS designs" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`designID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere gekaufte-itemstabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS items_buyed" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`item` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Leveltabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS levels" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`xp` VARCHAR(255) NOT NULL , " +
                "`level` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Premiumtabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS premium" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Server-Bantabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS server_bans" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Nutzer-Bantabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS user_bans" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`clientID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Servertabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS guilds" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`channelID` VARCHAR(255) NOT NULL , " +
                "`languageCode` VARCHAR(255) NOT NULL , " +
                "`roomID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Servertabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS strangers" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`channelID` VARCHAR(255) NOT NULL , " +
                "`language` VARCHAR(255) NOT NULL DEFAULT 'EN', " +
                "`connectID` VARCHAR(255) NOT NULL DEFAULT '', " +
                "`time` TIMESTAMP(6) NOT NULL DEFAULT CURRENT_TIMESTAMP(6), " +
                "PRIMARY KEY (`id`))");

        // Generiere Sprachentabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS languages" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`code` VARCHAR(255) NOT NULL , " +
                "`name` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Räumetabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS rooms" +
                " ( " +
                "`code` INT(255) NOT NULL AUTO_INCREMENT, " +
                "`name` VARCHAR(255) NOT NULL , " +
                "`categorie` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`code`))");

        // Generiere Räumetabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS room_categories" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT, " +
                "`name` VARCHAR(255) NOT NULL , " +
                "`reaction` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Wortblacklisttabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS word_blacklist" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`word` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Serverspezifische Wortblacklisttabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS sword_blacklist" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`word` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Autoupdatetabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS server_autoupdate" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`channelID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");

        // Generiere Serverspezifische Wortblacklisttabelle
        MySQL.update("CREATE TABLE IF NOT EXISTS suser_bans" +
                " ( " +
                "`id` INT(255) NOT NULL AUTO_INCREMENT , " +
                "`guildID` VARCHAR(255) NOT NULL , " +
                "`clientID` VARCHAR(255) NOT NULL , " +
                "PRIMARY KEY (`id`))");
    }
}
