package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class AddOffenseCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("wf", "wordfilter", "blacklistword", "banword", "bw");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.UNKNOWN;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 1) return;
        if (Main.getSheepManager().botOwners.contains(e.getAuthor().getId())) {
            if (!getGlobalManager().alreadyGlobalBlacklisted(args[0])) {
                MySQL.update("INSERT INTO word_blacklist (word) VALUES (?)", args[0]);
                sendMessage()
                        .setTitle("Word added")
                        .setDescription("Offense added to the general blacklist.")
                        .send(e.getChannel());
            } else {
                sendErrorMessage()
                        .setDescription("Word already registered on our server.")
                        .send(e.getChannel());
            }
        } else if (e.getMember().hasPermission(Permission.ADMINISTRATOR)) {
            if (!getGlobalManager().alreadyServerBlacklisted(e.getGuild(), args[0])) {
                MySQL.update("INSERT INTO sword_blacklist (guildID, word) VALUES (?, ?)", e.getGuild().getId(), args[0]);
                sendMessage()
                        .setTitle("Word added")
                        .setDescription("Offense added to your server's list.")
                        .send(e.getChannel());
            } else {
                sendErrorMessage()
                        .setDescription("Word already registered on your server's list.")
                        .send(e.getChannel());
            }
        } else {
            sendErrorMessage()
                    .setDescription("You dont have the permission to do this.")
                    .send(e.getChannel());
        }


    }
}
