package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 17.12.20
 ********************************/

public class AutoUpdateCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("autodesc", "descupdate", "autodescupdate", "descupdater");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getGlobalManager().isDescRegistered(e.getGuild(), e.getChannel())) {
            MySQL.update("INSERT INTO server_autoupdate (guildID, channelID) VALUES (?, ?)", e.getGuild().getId(), e.getChannel().getId());
            sendMessage()
                    .setTitle("Sheepstar Autodesc")
                    .setDescription("You turned on auto description update. To turn off, use the same command again.")
                    .send(e.getChannel());
        } else {
            MySQL.update("DELETE FROM server_autoupdate WHERE guildID=? AND channelID=?", e.getGuild().getId(), e.getChannel().getId());
            sendMessage()
                    .setTitle("Sheepstar Autodesc")
                    .setDescription("You turned off auto description update. To turn on, use the same command again.")
                    .send(e.getChannel());
        }
    }
}
