package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class BanServerCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("banserver", "bs", "serverban");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.BOT_OWNER;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 1) return;
        String serverName;
        try {
            serverName = Main.getInstance().getGuildById(args[0]).getName();
            if (!getGlobalManager().isBanned(Main.getInstance().getGuildById(args[0]))) {
                getGlobalManager().banServer(Main.getInstance().getGuildById(args[0]));
                sendMessage()
                        .setTitle("Sheepstar Ban")
                        .setDescription("The Server `" + serverName + "` got banned.")
                        .send(e.getChannel());
            } else {
                sendErrorMessage()
                        .setDescription("Whoa! This Server is already banned. Unban with `s!unbanserver <guildID>`")
                        .send(e.getChannel());
            }
        } catch (Exception err) {
            sendErrorMessage()
                    .setTitle("Sheepstar Error")
                    .setDescription("This Server does not exist")
                    .send(e.getChannel());
        }
    }
}
