package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class ChangeLanguageCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("lang", "lan", "language", "setlanguage", "changelanguage", "sl", "cl", "setlang");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("Wait! At first you should add this channel! `s!addGlobal`")
                    .send(e.getChannel());
            return;
        }
        if (args.length != 1) {
            sendErrorMessage()
                    .setDescription("Please choose a language: s!setLanguage <code>\nYou can find a list under s!languages")
                    .send(e.getChannel());
            return;
        }
        if (!getGlobalManager().isValidLanguage(args[0].toUpperCase())) {
            sendErrorMessage()
                    .setDescription("This language does not exist \nYou can find a list under s!languages")
                    .send(e.getChannel());

        } else {
            getGlobalManager().changeLanguageCode(e.getGuild(), e.getChannel(), args[0].toLowerCase());
            sendMessage()
                    .setTitle("Channel language updated")
                    .setDescription("You changed this language to " + args[0].toUpperCase() + "!")
                    .send(e.getChannel());
        }
    }
}
