package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.awt.*;
import java.util.Arrays;
import java.util.List;
import java.util.Locale;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class ChangeRoomCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("changeroom", "setroom", "sr", "room");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("Wait! At first you should add this channel! `s!addGlobal`")
                    .send(e.getChannel());
            return;
        }
        if (args.length != 1) {
            sendErrorMessage()
                    .setDescription("Please choose a room: s!room <code> \nYou can find a list under s!rooms")
                    .send(e.getChannel());
            return;
        }
        if (!getGlobalManager().isValidRoom(args[0].toLowerCase())) {
            sendErrorMessage()
                    .setDescription("This room does not exist.. \nYou can find a list under s!rooms")
                    .send(e.getChannel());

        } else {
            if (args[0].contains("p") && !getGlobalManager().hasPremium(e.getGuild())) {
                sendErrorMessage()
                        .setDescription("You must have Premium to enter this Channel")
                        .send(e.getChannel());
                return;
            }
            getGlobalManager().changeRoomID(e.getGuild(), e.getChannel(), args[0].toLowerCase());

            sendMessage()
                    .setTitle("Channel room updated")
                    .setDescription("You changed this room to " + args[0].toLowerCase() + "!")
                    .send(e.getChannel());
        }
    }
}
