package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.*;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 17.12.20
 ********************************/

public class DesignCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("design", "changedesign", "cdesign", "setdesign");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        ShopManager sm = new ShopManager(new LevelManager(e.getGuild()));
        if (args.length != 1) {
            sendErrorMessage()
                    .setDescription("Usage: s!design <number/reset>")
                    .send(e.getChannel());
            return;
        }
        if (args[0].equals("reset")) args[0] = "1";
        if (args[0].equals("5") && !Main.getSheepManager().botOwners.contains(e.getAuthor().getId())) {
            sendErrorMessage()
                    .setDescription("You are not allowed to use this Design. Please choose another")
                    .send(e.getChannel());
            return;
        }
        if (getGlobalManager().isValidDesign(args[0])) {
            if (sm.hasItem("design_"+args[0].toLowerCase()) || args[0].equals("1") || args[0].equals("5")) {
                getGlobalManager().updateDesign(e.getGuild(), args[0]);
                sendMessage()
                        .setTitle("Sheepstar design")
                        .setDescription("Your design has been updated to " + args[0])
                        .send(e.getChannel());
            } else {
                sendErrorMessage()
                        .setDescription("You dont own this. Please buy this from s!shop")
                        .send(e.getChannel());
            }

        } else {
            sendErrorMessage()
                    .setDescription("This is not a valid design. Please choose one from s!designs")
                    .send(e.getChannel());
            return;
        }
    }
}
