package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.LevelManager;
import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 18.12.20
 ********************************/

public class LeaderboardCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("top", "leaderboard", "toplist");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.UNKNOWN;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        LevelManager lm = new LevelManager(e.getGuild());
        String content = "";
        for (Guild current : lm.getTopList(10)) {
            content += "`"+current.getName()+" (Level "+ lm.getLevel(current) + ")`\n";
        }
        sendMessage()
                .setTitle("Sheepstar leaderboard")
                .setDescription(content)
                .send(e.getChannel());
    }
}
