package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.awt.*;
import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class RemoveGlobalCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("removeglobal", "deleteglobal", "rg", "dg");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (getStrangerManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setTitle("Wait a minute...")
                    .setDescription("You added this as an Connection. Disconnect with `s!disconnect`")
                    .send(e.getChannel());
            return;
        }
        if (!getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("You do not have a GlobalChat on your server yet.\n" +
                            "Add one with `s!addGlobal` in a fresh channel.")
                    .send(e.getChannel());

        } else {
            getGlobalManager().unregister(e.getGuild(), e.getChannel());
            sendMessage()
                    .setTitle("**Good bye!**")
                    .setDescription("The GlobalChat was removed. You can add it anytime" +
                            " with `s!addGlobal`.")
                    .send(e.getChannel());

        }
    }
}
