package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 11.12.20
 ********************************/

public class RemoveStrangerCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("disconnect", "disconnection", "removeconnect");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getStrangerManager().isRegistered(e.getGuild(), e.getChannel())) {
          sendErrorMessage()
                  .setTitle("Wait a minute...")
                  .setDescription("You do not have a Connection on your server yet.\n" +
                          "Add one with `s!connect [language-code]` in a fresh channel.")
                  .send(e.getChannel());
            return;
        }
        getStrangerManager().disconnect(e.getChannel(), getStrangerManager().getConnectID(e.getGuild(), e.getChannel()));
        getStrangerManager().unregister(e.getGuild(), e.getChannel());
    }
}
