package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class SetPremiumCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("setPreimum", "makePremium", "premium");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.BOT_OWNER;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        Guild guild = e.getGuild();
        boolean changed = false;
        if (args.length == 1) {
                try {
                    guild = Main.getInstance().getGuildById(args[0]);
                    changed = true;
                } catch (Exception err) {}
        }
        if (getGlobalManager().hasPremium(guild)) {
            sendErrorMessage()
                    .setDescription("Nice! This Server already has Premium.")
                    .send(e.getChannel());
            return;
        }
        getGlobalManager().setPremium(guild);
        if (!changed) {
            e.getGuild().retrieveOwner().queue(owner -> {
                sendMessage()
                        .setTitle("Sheepstar Premium")
                        .setDescription(owner.getAsMention() + ", this Server now has Premium. " +
                                Main.getInstance().getEmotesByName("Sstar_nitro", false).get(0).getAsMention())
                        .send(e.getChannel());
            });
        } else {
            sendMessage()
                    .setTitle("Sheepstar Premium")
                    .setDescription("You gave this Server Sheepstar Premium")
                    .send(e.getChannel());
        }
        try {
            Guild finalGuild = guild;
            guild.retrieveOwner().queue(owner -> {
              owner.getUser().openPrivateChannel().queue(m -> {
                  m.sendMessage("**You are a Legend!** \nYour Server `"+ finalGuild.getName() +"` has now Sheepstar Global Premium! \nCheck! We lit! " +
                          Main.getInstance().getEmotesByName("MathiasD", false).get(0).getAsMention()).queue();
              });
            });
        } catch (Exception err) {}
    }
}
