package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.*;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.entities.Emote;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 18.12.20
 ********************************/

public class ShopCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("shop", "shoplist", "buylist");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.UNKNOWN;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        Emote owned = Main.getInstance().getEmotesByName("Sstar_tick", false).get(0);
        LevelManager lm = new LevelManager(e.getGuild());
        ShopManager sm = new ShopManager(lm);
        StringBuilder sb = new StringBuilder();
        ShopItems.shopItems.forEach((name, item) -> {
            String priceString = "";
            if (getGlobalManager().hasPremium(e.getGuild())) {
                priceString =
                        (item.getPrice().equals(item.getPremiumPrice()))
                                ? "**"+item.getPrice() + " lvl**"
                                : "~~" + item.getPrice() + "~~ **" + item.getPremiumPrice() + " lvl**";
            } else {
                priceString = "**" + item.getPrice() + "**";
            }

            String ownLine = "";
            if (item.isMultiple_buyable()) {
                if (name.equals("channel")) {
                    ownLine = "(" + String.valueOf(getGlobalManager().getCount(e.getGuild())) + "/"+ String.valueOf(sm.getItemCount(name)) + ")";
                } else if (name.equals("booster")) {
                    ownLine = "(" + String.valueOf(sm.getItemCount(name)+1) + "x)";
                } else {
                    ownLine = "(" + String.valueOf(sm.getItemCount(name)) + ")";
                }
            } else if (sm.hasItem(name)) {
                ownLine = owned.getAsMention();
            } else {
                ownLine = "";
            }
            sb
                    .append("`")
                    .append(name)
                    .append("` (")
                    .append(item.getDescription())
                    .append(") ")
                    .append(priceString)
                    .append(" "+ownLine)
                    .append("\n");
        });
        sendMessage()
                .setTitle("Global Shop :shopping_cart:")
                .setDescription(sb.toString())
                .setFooter("Buy items with s!buy <name>")
                .send(e.getChannel());
    }
}
