package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.sql.ResultSet;
import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class ShowLanguagesCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("languages", "langs", "ls");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        ResultSet rsb = MySQL.getResult("SELECT * FROM guilds WHERE guildID=? AND channelID=?", e.getGuild().getId(), e.getChannel().getId());
        String currentRoom = "";
        try {
            while (rsb.next()) {
                currentRoom = rsb.getString("languageCode");
            }
        } catch (Exception err) {}
        ResultSet rs = MySQL.getResult("SELECT * FROM languages");
        String msgContent = "";
        try {
            int count = 0;
            while (rs.next()) {
                if (count != 0) msgContent += "\n";
                ResultSet rst = MySQL.getResult("SELECT * FROM guilds WHERE languageCode=?", rs.getString("code"));
                int roomCount = 0;
                try {
                    while (rst.next()) {
                        roomCount++;
                    }
                } catch (Exception err) {}
                count++;
                msgContent += "`[code] - [name] | [mem] Servers`"
                        .replace("[code]", rs.getString("code"))
                        .replace("[name]", rs.getString("name"))
                        .replace("[mem]", String.valueOf(roomCount))
                        + ((rs.getString("code").toLowerCase().equals(currentRoom.toLowerCase())) ? " " + Main.getInstance().getEmotesByName("Sstar_larrow", true)
                        .get(0).getAsMention(): "");
            }
        } catch (Exception err) {}
        sendMessage()
                .setTitle("Sheepstar languages")
                .setDescription(msgContent)
                .setThumbnail(null)
                .setFooter("Change with s!lang <code>")
                .send(e.getChannel());
    }
}
