package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.entities.Message;
import net.dv8tion.jda.api.entities.MessageEmbed;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.sql.ResultSet;
import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class ShowRoomsCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("rooms", "rs", "showrooms", "listrooms");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        ResultSet rs = MySQL.getResult("SELECT * FROM room_categories");
        String msgContent = "";

        try { int count = 0;
            while (rs.next()) {
                if (count != 0) msgContent += "\n"; count++;
                msgContent += "`"+rs.getString("name")+"` "+Main.getInstance().getEmotesByName(rs.getString("reaction"), false).get(0).getAsMention();
            } } catch (Exception err) {}

        MessageEmbed msg = sendMessage()
                .setTitle("Sheepstar rooms")
                .setDescription(msgContent)
                .setThumbnail(null)
                .setFooter("Change with s!room <code>")
                .get();
        e.getChannel().sendMessage(msg).queue(message -> {
            message.addReaction("⬅️").queue();
            ResultSet rst = MySQL.getResult("SELECT * FROM room_categories");
            try {
                while (rst.next()) {
                    message.addReaction(Main.getInstance().getEmotesByName(rst.getString("reaction"), false).get(0)).queue();
                }
            } catch (Exception err) { }
        });
    }
}
