package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 19.12.20
 ********************************/

public class SkipConnectionCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("skip", "skipc");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        String currentLanguage = getStrangerManager().getLanguage(e.getGuild(), e.getChannel());
        sendMessage()
                .setTitle("Connection skipped")
                .setDescription("You will be connected asap.")
                .send(e.getChannel());
        getStrangerManager().disconnect(e.getChannel(), getStrangerManager().getConnectID(e.getGuild(), e.getChannel()));
        getStrangerManager().connect(e.getGuild(), e.getChannel(), currentLanguage);
    }
}
