package de.sheepstar.globalWrapper.commands;

import de.sheepstar.globalWrapper.api.SheepPermission;
import de.sheepstar.globalWrapper.api.SheepstarGuildCommand;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.Permission;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.12.20
 ********************************/

public class UnbanServerCommand extends SheepstarGuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("unbanserver", "unbs", "ubs", "unbans");
    }

    @Override
    public SheepPermission getPermission() {
        return SheepPermission.BOT_OWNER;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 1) return;
        String serverName;
        try {
            serverName = Main.getInstance().getGuildById(args[0]).getName();
            if (getGlobalManager().isBanned(Main.getInstance().getGuildById(args[0]))) {
                getGlobalManager().unbanServer(Main.getInstance().getGuildById(args[0]));
                sendMessage()
                        .setTitle("Sheepstar Unban")
                        .setDescription("The Server `" + serverName + "` got unbanned.")
                        .send(e.getChannel());
            } else {
                sendErrorMessage()
                        .setDescription("This Server is not banned. Ban with `s!banserver <guildID>`")
                        .send(e.getChannel());

            }
        } catch (Exception err) {
            sendErrorMessage()
                    .setDescription("This server does not exist")
                    .send(e.getChannel());
        }
    }
}
