package de.sheepstar.globalWrapper.listeners;

import de.sheepstar.globalWrapper.api.messagebuilder.MessageBuilder;
import de.sheepstar.globalWrapper.api.messagebuilder.MessageType;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.entities.Emote;
import net.dv8tion.jda.api.entities.MessageEmbed;
import net.dv8tion.jda.api.events.message.react.MessageReactionAddEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import org.jetbrains.annotations.NotNull;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.HashMap;

/********************************
 * @author Mathias Wagner
 * Created 16.12.20
 ********************************/

public class RoomReactionListener extends ListenerAdapter {

    @Override
    public void onMessageReactionAdd(@NotNull MessageReactionAddEvent e) {
        e.getChannel().retrieveMessageById(e.getMessageId()).queue(msg -> {
            if (e.getUser().isBot()) return;
            if (!msg.getAuthor().isBot()) return;
            if (!msg.getAuthor().getName().contains("Sheepstar")) return;
            if (msg.getEmbeds().size() != 1) return;
            if (msg.getEmbeds().get(0).getFooter() == null) return;
            if (!msg.getEmbeds().get(0).getFooter().getText().contains("Change with")) return;
            HashMap<String, String> emotes = new HashMap<>();
            ResultSet rst = MySQL.getResult("SELECT * FROM room_categories");
            try {
                while (rst.next()) {
                    emotes.put(rst.getString("reaction"), rst.getString("id"));
                }
            } catch (Exception err) { }

            if (e.getReactionEmote().isEmoji()) {
                if (e.getReactionEmote().getEmoji().equals("⬅️")) {
                    ResultSet rs = MySQL.getResult("SELECT * FROM room_categories");
                    String msgContent = "";

                    try { int count = 0;
                        while (rs.next()) {
                            if (count != 0) msgContent += "\n"; count++;
                            msgContent += "`"+rs.getString("name")+"` "+Main.getInstance().getEmotesByName(rs.getString("reaction"), false).get(0).getAsMention();
                        } } catch (Exception err) {}

                    MessageEmbed newMsg = new MessageBuilder(MessageType.GREEN_MESSAGE)
                            .setTitle("Sheepstar rooms")
                            .setDescription(msgContent)
                            .setThumbnail(null)
                            .setFooter("Change with s!room <code>")
                            .get();
                    msg.editMessage(newMsg).queue();
                    msg.removeReaction(e.getReactionEmote().getEmoji(), e.getUser()).queue();
                    return;
                }
            }
            if (!emotes.containsKey(e.getReactionEmote().getName())) return;

            // Prepare Message

            String searchID = emotes.get(e.getReactionEmote().getName());

            ResultSet rsb = MySQL.getResult("SELECT * FROM guilds WHERE guildID=? AND channelID=?", e.getGuild().getId(), e.getChannel().getId());
            String currentRoom = "";
            String currentLang = "";
            try {
                while (rsb.next()) {
                    currentRoom = rsb.getString("roomID");
                    currentLang = rsb.getString("languageCode");
                }
            } catch (Exception err) {}
            ResultSet rs = MySQL.getResult("SELECT * FROM rooms WHERE categorie=?", searchID);
            String msgContent = "";

            try {
                int count = 0;
                while (rs.next()) {
                    if (count != 0) msgContent += "\n";

                    ResultSet rstb = MySQL.getResult("SELECT * FROM guilds WHERE roomID=? AND languageCode=?", rs.getString("code"), currentLang);
                    int roomCount = 0;
                    try {while (rstb.next()) {roomCount++;}} catch (Exception err) {}
                    count++;
                    msgContent += "`[code] - [name] | [mem] Servers`"
                            .replace("[code]", rs.getString("code"))
                            .replace("[name]", rs.getString("name"))
                            .replace("[mem]", String.valueOf(roomCount))
                            + ((rs.getString("code").toLowerCase().equals(currentRoom.toLowerCase())) ? " " + Main.getInstance().getEmotesByName("Sstar_larrow", true)
                            .get(0).getAsMention(): "");
                }
            } catch (Exception err) {}

            MessageEmbed newEmbed = new MessageBuilder(MessageType.GREEN_MESSAGE)
                    .setTitle("Sheepstar rooms")
                    .setDescription(msgContent)
                    .setFooter("Change with s!room <code>")
                    .get();
            msg.editMessage(newEmbed).queue();
            msg.removeReaction(e.getReactionEmote().getEmote(), e.getUser()).queue();

        });
    }

}
