package de.sheepstar.globalWrapper.listeners;

import de.sheepstar.globalWrapper.api.StrangerManager;
import de.sheepstar.globalWrapper.api.ValidationCheck;
import de.sheepstar.globalWrapper.api.sql.MySQL;
import de.sheepstar.globalWrapper.core.Main;
import net.dv8tion.jda.api.EmbedBuilder;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.entities.TextChannel;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import org.jetbrains.annotations.NotNull;

import java.sql.ResultSet;
import java.time.OffsetDateTime;
import java.time.ZoneId;

/********************************
 * @author Mathias Wagner
 * Created 17.12.20
 ********************************/

public class StrangerListener extends ListenerAdapter {

    @Override
    public void onGuildMessageReceived(@NotNull GuildMessageReceivedEvent e) {
        StrangerManager sm = Main.getStrangerManager();
        if (!sm.isRegistered(e.getGuild(), e.getChannel())) return;
        if (new ValidationCheck().validate(e)) {
            sendConnection(e, sm.getConnectID(e.getGuild(), e.getChannel()));
        }
    }

    public void sendConnection(GuildMessageReceivedEvent e, String connectID) {
        ResultSet rs = MySQL.getResult("SELECT * FROM strangers WHERE connectID=?", connectID);
        try {
            while (rs.next()) {
                try {
                    System.out.println(connectID);
                    System.out.println("debug");
                    Guild currentGuild = Main.getInstance().getGuildById(rs.getString("guildID"));
                    TextChannel currentChannel = currentGuild.getTextChannelById(rs.getString("channelID"));
                    EmbedBuilder eb = new EmbedBuilder();
                    String iconUrl = e.getGuild().getIconUrl();
                    if (iconUrl == null) iconUrl = "https://i.giphy.com/media/38pPhtupwYMerEQeBT/source.gif";
                    eb.setThumbnail(iconUrl);
                    eb.setTimestamp(OffsetDateTime.now().atZoneSameInstant(ZoneId.of("Europe/Berlin")));
                    String links = "[Support Server](https://discord.gg/jbne9JTJtU) ║ [Bot Invite](https://discord.com/api/oauth2/authorize?client_id=772513556116930580&permissions=321536&scope=bot)";
                    eb.addField("Links & Help", links, false);
                    eb.setFooter("Sent by " + e.getGuild().getName(), iconUrl);
                    if (e.getMessage().getAttachments().size() > 0) {
                        eb.setImage(e.getMessage().getAttachments().get(0).getUrl());
                    }
                    eb.setDescription(e.getMessage().getContentRaw());
                    eb.setAuthor(e.getAuthor().getAsTag(), null, e.getAuthor().getAvatarUrl());
                    eb.setColor(e.getMember().getColor());
                    currentChannel.sendMessage(eb.build()).queue();
                } catch (Exception err) {}
            }
        } catch (Exception err) {}
    }

}
