package xyz.sheepstar.wrapper.main.commands.essentials;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.core.Main;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 08.02.2021
 ********************************/

public class HelpCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("help", "bothelp");
    }

    @Override
    public PermissionNode getPermission() {
        return null;
    }

    @Override
   public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        sendMessage()
                .setTitle(getEmoteString("Sstar_info") + " Sheepstar help")
                .addField(":grey_question: How does ist work?", "Sheepstar is a bot that is divided into modules. " +
                        "Use the following commands to manage them:", false)
                .addField(":keyboard: Available modules", "`s!modules`", true)
                .addField(":keyboard: Activated modules", "`s!list`", true)
                .addField(":keyboard: Enable module", "`s!enable <moduleName>`", true)
                .addField(":keyboard: Disable module", "s!disable <moduleName>", true)
                .addField(":keyboard: Commands in module", "s!commands <moduleName>", true)
                .addField(":keyboard: Module information", "s!info <moduleName>", true)
                .send(e.getChannel());
    }
}
