package xyz.sheepstar.wrapper.main.commands.modules;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.util.api.builder.message.MessageBuilder;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 12.02.2021
 ********************************/

public class CommandInfoCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("commands");
    }

    @Override
    public PermissionNode getPermission() {
        return null;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 1) { sendUsage(e, "<moduleName>");return; }
        MessageBuilder builder = sendMessage();
        if (!moduleManager.isEnabled(e.getGuild(), args[0])) {
            sendErrorMessage().setDescription("This module is not activated").send(e.getChannel());
            return;
        }
        String prefix = getModulePrefix(e.getGuild(), args[0]);
        getCommands(args[0]).forEach((name, command) -> {
            builder.addField(":keyboard: "+name, "`"+prefix+command+"`", true);
        });
        builder.send(e.getChannel());
    }
}
