package xyz.sheepstar.wrapper.main.commands.modules;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 08.02.2021
 ********************************/

public class DisableModuleCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("disable", "disablemodule", "unloadmodule", "unload");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 1) { sendUsage(e,"<modul>");return; }
        if (!moduleManager.isEnabled(e.getGuild(), args[0])) {
            sendErrorMessage().setDescription("This module is not activated").send(e.getChannel());
            return;
        }
        moduleManager.disable(e.getGuild(), args[0].toLowerCase());
        sendMessage()
                .setTitle("Modul disabled.")
                .setDescription("Module `" + args[0] + "` disabled.")
                .send(e.getChannel());
    }
}
