package xyz.sheepstar.wrapper.main.commands.modules;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.util.api.builder.message.ColorType;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 24.01.2021
 ********************************/

public class EnableModuleCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("enablemodule", "activatemodule", "enable", "activate");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 2) { sendUsage(e,"<module> <prefix>");return; }
        // TODO: Secret Manager
        if (args[0].equals("SheepstarIs") && args[1].equals("CUTE")) {
            sendPlainMessage(e, "thank ya ;3");
            return;
        }
        if (!moduleManager.exists(args[0])) {
            sendErrorMessage().setDescription("This module does not exist.").send(e.getChannel());return;
        }
        if (moduleManager.usedWhereOther(e.getGuild(), args[1])) {
            sendErrorMessage().setDescription("The prefix is already in use.").send(e.getChannel());return;
        }

        moduleManager.enable(e.getGuild(), args[0].toLowerCase(), args[1]);
        sendMessage()
                .setTitle("Modul enabled.")
                .setDescription("Module `" + args[0] + "` enabled.")
                .send(e.getChannel());
    }
}
