package xyz.sheepstar.wrapper.main.commands.modules;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.core.Main;
import xyz.sheepstar.wrapper.util.api.builder.message.MessageBuilder;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 08.02.2021
 ********************************/

public class ListModulesCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("prefixes", "enabled", "list");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {

        StringBuilder sb = new StringBuilder();
        MessageBuilder mb = sendMessage()
                .setTitle("Enabled modules");
        Main.getDB()
                .selectFrom("enabled_modules")
                .where("guildID", e.getGuild().getId())
                .getResult()
                .getMultipleList("name", "prefix")
                .forEach((v1, v2) -> {
                    mb.addField(toCamelCase(v1), "`"+v2+"help`", true);
                });
        if (sb.toString().isEmpty()) sb.append("Currently no module is active. Activate one with **%pre%enable <moduleName>** look at a list with **%pre%modules**".replace("%pre%", getPrefix(e.getGuild())));
        else mb.setFooter("Look at a list with **%pre%modules**".replace("%pre%", getPrefix(e.getGuild())));
        mb.send(e.getChannel());
    }
}
