package xyz.sheepstar.wrapper.main.commands.modules;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.core.Main;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.sql.ResultSet;
import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class ModuleInfoCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("info", "moduleinfo");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (args.length != 1) {
            sendUsage(e, "<moduleName>");
            return;
        }
        if (!moduleManager.exists(args[0])) {
            sendErrorMessage()
                    .setDescription("This module does not exist.")
                    .send(e.getChannel());
            return;
        }
        Main.getDB().getResult("SELECT * FROM existing_modules WHERE name=?", args[0]).getMultipleList("description", "icon_url").forEach((description, icon_url) -> {
            sendMessage()
                    .setTitle(toCamelCase(args[0] + " module"))
                    .setDescription(description)
                    .setThumbnail(icon_url)
                    .send(e.getChannel());
        });
    }
}
