package xyz.sheepstar.wrapper.main.commands.trending;

import net.dv8tion.jda.api.entities.Guild;
import xyz.sheepstar.wrapper.core.Main;

import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 13.02.2021
 ********************************/

public class LeaderboardCacheUpdater extends Thread {

    @Override
    public void run() {

        List<Guild> guildList = new ArrayList<>(Main.getJDA().getGuildCache().asList());
        HashMap<Guild, Long> tempMap = new HashMap<>();

        guildList.sort(Comparator
                .comparingDouble((Guild guild) -> guild.loadMembers().get()
                        .stream()
                        .filter(member -> !member.getUser().isBot())
                        .count())
                .reversed());

        guildList.sort(Comparator.comparingDouble(Guild::getMemberCount)
                .reversed());
        guildList.forEach(guild -> {
            if (Main.getSettingsManager().get(guild, "showInTrends").equals("true")) {
                tempMap.put(guild, guild.loadMembers().get().stream().filter(member -> !member.getUser().isBot()).count());
            }
        });
        LeaderboardManager.guildCache.clear();
        tempMap.forEach(LeaderboardManager.guildCache::put);

        try { Thread.sleep(300000); } catch (Exception ignored) { }
        run();
    }
}
