package xyz.sheepstar.wrapper.modules.chat.api;

import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.entities.TextChannel;
import xyz.sheepstar.wrapper.core.Main;

import java.sql.ResultSet;

/********************************
 * @author Mathias Wagner
 * Created 13.12.20
 ********************************/

public class ChatManager {

    public boolean isRegistered(Guild guild, TextChannel channel) {
        return Main.getDB().getResult("SELECT * FROM chat_channels WHERE guildID=? AND channelID=?", guild.getId(), channel.getId()).getRowCount() == 1;
    }

    public String getLanguage(Guild guild, TextChannel channel) {
        return Main.getDB().getResult("SELECT * FROM chat_channels WHERE guildID=? AND channelID=?", guild.getId(), channel.getId()).getString("language");
    }

    public void setLanguage(String langCode, Guild guild, TextChannel channel) {
        if (!isRegistered(guild, channel)) return;
        Main.getDB().update("UPDATE chat_channels SET language=? WHERE guildID=? AND channelID=?", langCode, guild.getId(), channel.getId());
    }

    public void register(Guild guild, TextChannel channel) {
        if (isRegistered(guild, channel)) return;
        Main.getDB().update("INSERT INTO chat_channels (guildID, channelID, language) VALUES (?, ?, 'EN')", guild.getId(), channel.getId());
    }

    public void unregister(Guild guild, TextChannel channel) {
        if (!isRegistered(guild, channel)) return;
        Main.getDB().update("DELETE FROM chat_channels WHERE guildID=? AND channelID=?", guild.getId(), channel.getId());
    }

}
