package xyz.sheepstar.wrapper.modules.chat.api;

import com.google.api.gax.rpc.ApiException;
import com.google.cloud.dialogflow.v2.QueryResult;
import net.dv8tion.jda.api.entities.Emote;
import net.dv8tion.jda.api.entities.User;
import xyz.sheepstar.wrapper.util.api.GuildEssentials;

import java.util.Collections;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 06.09.20
 ********************************/

public class DialogflowProcess extends GuildEssentials {

    public String processMessage(String lang, User user, String msg) {
        try {
            String txt = detectIntentTexts("sheepstar-vyqb", Collections.singletonList(msg), user.getId(), (lang.equals("DE") ? "de" : "en"));
            txt = txt.replace("%mention%", user.getAsMention())
                    .replace("%tag%", user.getAsTag());
            for (String current : txt.split(" ")) {
                if (current.startsWith(":") && current.endsWith(":")) {
                    String emoteName = current.replace(":", "");
                    try {
                        Emote emote = getEmote(emoteName);
                        txt = txt.replace(current, emote.getAsMention());
                    } catch (Exception err) {}
                }
            }
            return (txt.isEmpty() ? "Connection to Servers lost." : txt);
        } catch (Exception err) {}
        return "Connection to API Servers lost.";
    }


    public static String detectIntentTexts(String projectId, List<String> texts, String sessionId, String languageCode)
            throws ApiException {
        try (com.google.cloud.dialogflow.v2.SessionsClient sessionsClient = com.google.cloud.dialogflow.v2.SessionsClient.create()) {
            com.google.cloud.dialogflow.v2.SessionName session = com.google.cloud.dialogflow.v2.SessionName.of(projectId, sessionId);
            for (String text : texts) {
                com.google.cloud.dialogflow.v2.TextInput.Builder textInput = com.google.cloud.dialogflow.v2.TextInput.newBuilder().setText(text).setLanguageCode(languageCode);
                com.google.cloud.dialogflow.v2.QueryInput queryInput = com.google.cloud.dialogflow.v2.QueryInput.newBuilder().setText(textInput).build();

                com.google.cloud.dialogflow.v2.DetectIntentResponse response = sessionsClient.detectIntent(session, queryInput);
                QueryResult queryResult = response.getQueryResult();

                return queryResult.getFulfillmentText();
            }
        } catch (Exception err) {
            err.printStackTrace();
            return "Connection to Servers lost.";
        }
        return "Connection to Servers lost.";
    }

}
