package xyz.sheepstar.wrapper.modules.chat.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.chat.api.ChatCommand;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 11.02.2021
 ********************************/

public class AddChatCommand extends ChatCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("addchat", "addchatchannel", "ac");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (getChatManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("This channel is already an chat-channel. Remove it with s!removechat")
                    .send(e.getChannel());
        } else {
            getChatManager().register(e.getGuild(), e.getChannel());
            sendMessage()
                    .setTitle("Channel added")
                    .setDescription("This channel is now an chat-channel")
                    .send(e.getChannel());
        }
    }
}
