package xyz.sheepstar.wrapper.modules.chat.listeners;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import org.jetbrains.annotations.NotNull;
import xyz.sheepstar.wrapper.modules.chat.api.ChatCommand;
import xyz.sheepstar.wrapper.modules.chat.api.ChatManager;
import xyz.sheepstar.wrapper.modules.chat.api.DialogflowProcess;
import xyz.sheepstar.wrapper.util.api.listener.GuildListener;

/********************************
 * @author Mathias Wagner
 * Created 11.02.2021
 ********************************/

public class MessageSentListener extends GuildListener {

    @Override
    public void onGuildMessageReceived(@NotNull GuildMessageReceivedEvent event) {
        if (!isValid(event.getGuild())) return;
        if (event.getAuthor().isBot()) return;
        ChatManager cm = ChatCommand.getChatManager();
        if (!cm.isRegistered(event.getGuild(), event.getChannel())) return;
        
        sendPlainMessage(event, new DialogflowProcess().processMessage(
                cm.getLanguage(event.getGuild(), event.getChannel()),
                event.getAuthor(),
                event.getMessage().getContentRaw()
        ));
    }
}
