package xyz.sheepstar.wrapper.modules.counter.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.counter.api.Manager;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 08.02.2021
 ********************************/

public class MonitorListCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("monitors", "list");
    }

    @Override
    public PermissionNode getPermission() {
        return null;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        StringBuilder descString = new StringBuilder();
        Manager.monitorList.forEach(monitor -> {
            descString.append(toCamelCase(monitor) + "\n");
        });
        sendMessage()
                .setTitle("Counter monitors")
                .setDescription(descString.toString())
                .setFooter("Use " + moduleManager.getPrefix(e.getGuild(), "counter") + "<monitor> <text/voice> to create a stats channel")
                .send(e.getChannel());
    }
}
