package xyz.sheepstar.wrapper.modules.counter.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.counter.action.MemberUpdate;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;
import xyz.sheepstar.wrapper.util.api.sql.StorageMedium;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 09.02.2021
 ********************************/

public class SetupCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Collections.singletonList("setup");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        StorageMedium storage = new StorageMedium(e.getGuild(), "counter_channels");
        e.getGuild().createCategory("\uD83D\uDC65▎Stats").setPosition(1).queue(category -> {
            if (!storage.exists("allmembers_id")) {
                category.createVoiceChannel("\uD83D\uDC65▎All Members: 0").queue(voiceChannel -> {
                    storage.insert("allmembers_id", voiceChannel.getId());
                    new MemberUpdate().update(e.getGuild());
                });
            }

            if (!storage.exists("member_id")) {
               category.createVoiceChannel("\uD83D\uDC65▎Members: 0").queue(voiceChannel -> {
                    storage.insert("member_id", voiceChannel.getId());
                   new MemberUpdate().update(e.getGuild());
                });
            }

            if (!storage.exists("bots_id")) {
                category.createVoiceChannel("\uD83D\uDC65▎Bots: 0").queue(voiceChannel -> {
                    storage.insert("bots_id", voiceChannel.getId());
                    new MemberUpdate().update(e.getGuild());
                });
            }
        });

        sendMessage()
                .setDescription("You have successfully created a stats category!")
                .send(e.getChannel());
    }
}
