package xyz.sheepstar.wrapper.modules.counter.listeners;

import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.events.channel.text.TextChannelDeleteEvent;
import net.dv8tion.jda.api.events.channel.voice.VoiceChannelDeleteEvent;
import net.dv8tion.jda.api.hooks.ListenerAdapter;
import org.jetbrains.annotations.NotNull;
import xyz.sheepstar.wrapper.util.api.listener.GuildListener;
import xyz.sheepstar.wrapper.util.api.sql.StorageMedium;

/********************************
 * @author Mathias Wagner
 * Created 08.02.2021
 ********************************/

public class CounterDelete extends GuildListener {

    @Override
    public void onTextChannelDelete(@NotNull TextChannelDeleteEvent e) {
        if (!isValid(e.getGuild())) return;
        delete(e.getGuild(), e.getChannel().getId());
    }

    @Override
    public void onVoiceChannelDelete(@NotNull VoiceChannelDeleteEvent e) {
        if (!isValid(e.getGuild())) return;
        delete(e.getGuild(), e.getChannel().getId());
    }


    public void delete(Guild guild, String id) {
        StorageMedium storage = new StorageMedium(guild, "counter_channels");
        if (storage.existsValue(id)) storage.deleteValue(id);
    }

}
