package xyz.sheepstar.wrapper.modules.global.api;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.core.Main;
import xyz.sheepstar.wrapper.util.api.GuildEssentials;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class ValidationCheck extends GuildEssentials {

    public boolean validate(GuildMessageReceivedEvent e) {
        GlobalManager gm = GlobalCommand.globalManager;
        String messageContent = e.getMessage().getContentRaw();
        String lowerContent = e.getMessage().getContentRaw().toLowerCase();
        if (e.getAuthor().isBot()) return false;

        if (messageContent.startsWith(moduleManager.getPrefix(e.getGuild(), "global"))) return false;
        if (messageContent.startsWith(guildManager.getPrefix(e.getGuild()))) return false;

        if (e.getMessage().getContentRaw().startsWith("=")) { e.getMessage().addReaction(getEmote("Sstar_cross")).queue();return false; }

        try {
            e.getMessage().delete().queue();
        } catch (Exception err) { return false; }

        // TODO: guten spamschutz einbauen



        // TODO: Schaun ob Server & User gebannt


        // Check if Message Contains Ads TODO: überprüfen ob owner is, die dürfen werbung machen
        String msg = e.getMessage().getContentRaw().toLowerCase();
        if ((msg.contains("http://") ||
                msg.contains("https://") ||
                msg.contains("www."))) {
            sendErrorMessage()
                    .setDescription(e.getAuthor().getAsMention() + ", you are not allowed to send links here.")
                    .send(e.getChannel());
            return false;
        }

        if (isBlocked(e.getMessage().getContentRaw()) || isServerBlocked(e.getGuild().getId(), e.getMessage().getContentRaw())) {
            sendMessage()
                    .setDescription(e.getAuthor().getAsMention() + ", you are not allowed to offend here.")
                    .send(e.getChannel());
            return false;
        }
        return true;
    }

    public boolean isServerBlocked(String guildID, String msgContent) {
        msgContent = msgContent.replace(" ", "");
        return Main.getDB().getResult("SELECT * FROM global_custom_blacklist WHERE guildID=? AND ? LIKE concat('%', word, '%')",
                                        guildID, msgContent).getRowCount() == 1;
    }

    public boolean isBlocked(String msgContent) {
        msgContent = msgContent.replace(" ", "");
        return Main.getDB().getResult("SELECT * FROM global_blacklist WHERE ? LIKE concat('%', word, '%')", msgContent)
                .getRowCount() == 1;
    }

}
