package xyz.sheepstar.wrapper.modules.global.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.global.api.GlobalCommand;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 09.02.2021
 ********************************/

public class AddGlobalCommand extends GlobalCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("addglobal", "ag");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("You already have this GlobalChat on your server.")
                    .send(e.getChannel());
            return;
        }

        getGlobalManager().register(e.getGuild(), e.getChannel());
        sendMessage()
                .setTitle("**__Welcome to the Global Chat of Sheepstar__**")
                .setDescription("**:warning: Warning**: \n" +
                        "Everything written here will be sent to all servers connected to <@772513556116930580>. " +
                        "For questions and help, contact our team on the [Support Server](https://discord.gg/jbne9JTJtU) \n" +
                        "Furthermore, you and your server team have the duty to make sure that the rules in the Global Chat are followed! \n" +
                        "If this is not the case, your server will be immediately excluded from Global Chat.")
                .send(e.getChannel());

    }
}
