package xyz.sheepstar.wrapper.modules.global.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.global.api.GlobalCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class ChangeLanguageCommand extends GlobalCommand {

    @Override
    public List<String> getAlias() {
        return Arrays.asList("setlanguage", "lan", "language", "lang", "changelanguage", "sl", "cl", "setlang");
    }

    @Override
    public PermissionNode getPermission() {
        return null;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("Wait! At first you should add this channel! `s!addGlobal`")
                    .send(e.getChannel());
            return;
        }
        if (args.length != 1) {
            sendUsage(e, "<code>\nYou can find a list under s!languages");
            return;
        }
        if (!getGlobalManager().isValidLanguage(args[0])) {
            sendErrorMessage()
                    .setDescription("This language does not exist\nYou can find a list under s!languages")
                    .send(e.getChannel());
            return;
        }
        getGlobalManager().changeLanguage(e.getChannel(), args[0]);
        sendMessage()
                .setTitle("Channel language updated")
                .setDescription("You changed this language to " + args[0].toUpperCase() + "!")
                .send(e.getChannel());
    }
}
