package xyz.sheepstar.wrapper.modules.global.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.global.api.GlobalCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class ChangeRoomCommand extends GlobalCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("changeroom", "setroom", "sr", "room");
    }

    @Override
    public PermissionNode getPermission() {
        return null;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("Wait! At first you should add this channel! `s!addGlobal`")
                    .send(e.getChannel());
            return;
        }
        if (args.length != 1) {
            sendUsage(e, " <code> \nYou can find a list under s!rooms");
            return;
        }
        if (!getGlobalManager().isValidRoom(args[0].toLowerCase())) {
            sendErrorMessage()
                    .setDescription("This room does not exist.. \nYou can find a list under s!rooms")
                    .send(e.getChannel());
            return;
        }
        if (args[0].contains("p") && !guildManager.hasPremium(e.getGuild())) {
            sendErrorMessage()
                    .setDescription("You must have Premium to enter this Channel")
                    .send(e.getChannel());
            return;
        }
        getGlobalManager().changeRoom(e.getChannel(), args[0]);

        sendMessage()
                .setTitle("Channel room updated")
                .setDescription("You changed this room to " + args[0].toLowerCase() + "!")
                .send(e.getChannel());
    }
}
