package xyz.sheepstar.wrapper.modules.global.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.global.api.GlobalCommand;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class RemoveGlobalCommand extends GlobalCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("removeglobal", "remove", "delete", "deleteglobal", "unregister");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (!getGlobalManager().isRegistered(e.getGuild(), e.getChannel())) {
            sendErrorMessage()
                    .setDescription("You do not have a GlobalChat on your server yet.\n" +
                            "Add one with `s!addGlobal` in a fresh channel.")
                    .send(e.getChannel());
            return;
        }
        getGlobalManager().unregister(e.getGuild(), e.getChannel());
        sendMessage()
                .setTitle("**Good bye!**")
                .setDescription("The GlobalChat was removed. You can add it anytime" +
                        " with `s!addGlobal`.")
                .send(e.getChannel());
    }
}
