package xyz.sheepstar.wrapper.modules.global.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.core.Main;
import xyz.sheepstar.wrapper.modules.global.api.GlobalCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.sql.ResultSet;
import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class ShowLanguagesCommand extends GlobalCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("languages", "langs");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        String currentLang = getGlobalManager().getLanguage(e.getChannel());
        ResultSet rs = Main.getDB().getResultSet("SELECT * FROM global_languages");
        String msgContent = "";
        try {
            while (rs.next()) {
                if (!msgContent.isEmpty()) msgContent += "\n";
                int roomCount = Main.getDB().getResult("SELECT * FROM global_channels WHERE language=?", rs.getString("code")).getRowCount();
                msgContent += "`%code% - %name% | %mem% Servers`"
                        .replace("%code%", rs.getString("code"))
                        .replace("%name%", rs.getString("name"))
                        .replace("%mem%", String.valueOf(roomCount));
                if (rs.getString("code").toLowerCase().equals(currentLang.toLowerCase()))
                    msgContent += " "+ getEmoteString("Sstar_larrow");
            }
        } catch (Exception ignored) {}
        sendMessage()
                .setTitle("Sheepstar languages")
                .setDescription(msgContent)
                .setFooter("Change with s!lang <code>")
                .send(e.getChannel());
    }
}
