package xyz.sheepstar.wrapper.modules.global.commands;

import net.dv8tion.jda.api.entities.MessageEmbed;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import net.dv8tion.jda.api.events.message.react.MessageReactionAddEvent;
import org.jetbrains.annotations.NotNull;
import xyz.sheepstar.wrapper.core.Main;
import xyz.sheepstar.wrapper.modules.global.api.GlobalCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.sql.ResultSet;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 10.02.2021
 ********************************/

public class ShowRoomsCommand extends GlobalCommand {

    @Override
    public List<String> getAlias() {
        return Arrays.asList("rooms", "showrooms");
    }

    @Override
    public PermissionNode getPermission() {
        return null;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        ResultSet rs = Main.getDB().getResultSet("SELECT * FROM global_categories");
        String msgContent = "";

        try {
            while (rs.next()) {
                if (!msgContent.isEmpty()) msgContent += "\n";
                msgContent += "`"+rs.getString("name")+"` "+getEmoteString(rs.getString("reaction"));
            } } catch (Exception err) {}

        MessageEmbed msg = sendMessage()
                .setTitle("Sheepstar rooms")
                .setDescription(msgContent)
                .setFooter("Change with s!room <code>")
                .get();
        e.getChannel().sendMessage(msg).queue(message -> {
            message.addReaction("⬅️").queue();
            try {
                ResultSet rsb = Main.getDB().getResultSet("SELECT * FROM global_categories");
                while (rsb.next()) {
                    try {
                        message.addReaction(getEmote(rsb.getString("reaction"))).queue();
                    } catch (Exception ignored) { }
                }
            } catch (Exception err) { }
        });
    }

    @Override
    public void onMessageReactionAdd(@NotNull MessageReactionAddEvent e) {
        if (!isValid(e.getGuild())) return;
        e.getChannel().retrieveMessageById(e.getMessageId()).queue(msg -> {
            if (e.getUser().isBot()) return;
            if (!msg.getAuthor().isBot()) return;
            if (!msg.getAuthor().getName().contains("Sheepstar")) return;
            if (msg.getEmbeds().size() != 1) return;
            if (msg.getEmbeds().get(0).getFooter() == null) return;
            if (!msg.getEmbeds().get(0).getFooter().getText().contains("Change with")) return;
            HashMap<String, String> emotes = new HashMap<>();
            ResultSet rst = Main.getDB().getResultSet("SELECT * FROM global_categories");
            try {
                while (rst.next()) {
                    emotes.put(rst.getString("reaction"), rst.getString("id"));
                }
            } catch (Exception err) { }

            if (e.getReactionEmote().isEmoji()) {
                if (e.getReactionEmote().getEmoji().equals("⬅️")) {
                    msg.removeReaction(e.getReactionEmote().getEmoji(), e.getUser()).queue();
                    ResultSet rs = Main.getDB().getResultSet("SELECT * FROM global_categories");
                    String msgContent = "";

                    try { int count = 0;
                        while (rs.next()) {
                            if (count != 0) msgContent += "\n"; count++;
                            msgContent += "`"+rs.getString("name")+"` "+getEmoteString(rs.getString("reaction"));
                        } } catch (Exception err) {}

                    MessageEmbed newMsg = sendMessage()
                            .setTitle("Sheepstar rooms")
                            .setDescription(msgContent)
                            .setThumbnail(null)
                            .setFooter("Change with s!room <code>")
                            .get();
                    msg.editMessage(newMsg).queue();
                    return;
                }
            } else {
                msg.removeReaction(e.getReactionEmote().getEmote(), e.getUser()).queue();
            }
            if (!emotes.containsKey(e.getReactionEmote().getName())) return;

            // Prepare Message

            String searchID = emotes.get(e.getReactionEmote().getName());

            ResultSet rsb = Main.getDB().getResultSet("SELECT * FROM global_channels WHERE guildID=? AND channelID=?", e.getGuild().getId(), e.getChannel().getId());
            String currentRoom = "";
            String currentLang = "";
            try {
                while (rsb.next()) {
                    currentRoom = rsb.getString("roomID");
                    currentLang = rsb.getString("language");
                }
            } catch (Exception err) {}
            ResultSet rs = Main.getDB().getResultSet("SELECT * FROM global_rooms WHERE category=?", searchID);
            String msgContent = "";

            try {
                int count = 0;
                while (rs.next()) {
                    if (count != 0) msgContent += "\n";

                    ResultSet rstb = Main.getDB().getResultSet("SELECT * FROM global_channels WHERE roomID=? AND language=?", rs.getString("code"), currentLang);
                    int roomCount = 0;
                    try {while (rstb.next()) {roomCount++;}} catch (Exception err) {}
                    count++;
                    msgContent += "`[code] - [name] | [mem] Servers`"
                            .replace("[code]", rs.getString("code"))
                            .replace("[name]", rs.getString("name"))
                            .replace("[mem]", String.valueOf(roomCount))
                            + ((rs.getString("code").toLowerCase().equals(currentRoom.toLowerCase())) ? " " + getEmoteString("Sstar_larrow") : "");
                }
            } catch (Exception err) {}

            MessageEmbed newEmbed = sendMessage()
                    .setTitle("Sheepstar rooms")
                    .setDescription(msgContent)
                    .setFooter("Change with s!room <code>")
                    .get();
            msg.editMessage(newEmbed).queue();
        });
    }
}
