package xyz.sheepstar.wrapper.modules.moderation.commands;

import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 11.02.2021
 ********************************/

public class BanCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("ban", "banuser");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (e.getMessage().getMentionedUsers().isEmpty()) { sendUsage(e, "<@user> [days] [reason]");return; }
        Member target = e.getMessage().getMentionedMembers().get(0);

        int days = -1;
        try { days = Integer.parseInt(args[1]); } catch (Exception err) {}

        int usedString = (days == -1 ? 1 : 2);
        String reason = "";
        for (int i=usedString; i < args.length; i++) reason += args[i]+" ";
        if (reason.isEmpty()) reason = "Not reason given";
        if (reason.endsWith(" ")) reason = reason.substring(0, reason.length() - 1);

        target.ban(days, reason).queue();

        sendMessage()
                .setThumbnail(target.getUser().getAvatarUrl())
                .setDescription("The member **"+target.getUser().getName()+"** got banned for **"+days+"** days.\nReason: `" + reason + "`")
                .send(e.getChannel());
    }
}
