package xyz.sheepstar.wrapper.modules.moderation.commands;

import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 11.02.2021
 ********************************/

public class KickCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("kick", "kickuser");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (e.getMessage().getMentionedUsers().isEmpty()) { sendUsage(e, "<@user> [reason]");return; }
        Member target = e.getMessage().getMentionedMembers().get(0);

        String reason = "";
        for (int i=1; i < args.length; i++) reason += args[i]+" ";
        if (reason.isEmpty()) reason = "Not reason given";
        if (reason.endsWith(" ")) reason = reason.substring(0, reason.length() - 1);

        target.kick(reason).queue();
        sendMessage()
                .setThumbnail(target.getUser().getAvatarUrl())
                .setDescription("The member **"+target.getUser().getName()+"** got kicked.\nReason: `" + reason + "`")
                .send(e.getChannel());

    }
}
