package xyz.sheepstar.wrapper.modules.moderation.commands;

import net.dv8tion.jda.api.entities.Member;
import net.dv8tion.jda.api.entities.Role;
import net.dv8tion.jda.api.entities.User;
import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.time.format.DateTimeFormatter;
import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 11.02.2021
 ********************************/

public class UserInfoCommand extends GuildCommand {
    @Override
    public List<String> getAlias() {
        return Arrays.asList("userinfo", "user");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        if (e.getMessage().getMentionedUsers().isEmpty()) { sendUsage(e, "<@user>");return; }
        Member target = e.getMessage().getMentionedMembers().get(0);

        StringBuilder roleText = new StringBuilder();
        List<Role> roleList = target.getRoles();
        roleList.forEach(role -> {
            if (!roleText.toString().isEmpty()) roleText.append(", ");
            roleText.append(role.getAsMention());
        });

        DateTimeFormatter format = DateTimeFormatter.ofPattern("dd-MM-yyyy HH:mm:ss");

        String boostedTime = "";
        if (target.getTimeBoosted() == null) boostedTime = ":x: Not boosting";
        else boostedTime = target.getTimeBoosted().format(format);

        sendMessage()
                .setTitle(":information_source: Userinfo")
                .addField(":id: Client-ID", target.getId(), true)
                .addField(":pencil: Username", target.getUser().getAsTag(), true)
                .addField(getEmoteString("Sstar_nitro")+" Boosting since", boostedTime, true)
                .addField(":open_file_folder: Roles ("+roleList.size()+")", roleText.toString(), true)
                .addField(":date: Joined date", target.getTimeJoined().format(format), true)
                .addField(":date: Creation date", target.getTimeCreated().format(format), true)
                .setColor(target.getColor())
                .setThumbnail(target.getUser().getAvatarUrl())
                .send(e.getChannel());
    }
}
