package xyz.sheepstar.wrapper.modules.voice.api;

import net.dv8tion.jda.api.entities.Category;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.entities.VoiceChannel;
import xyz.sheepstar.wrapper.core.Main;

/********************************
 * @author Mathias Wagner
 * Created 25.01.2021
 ********************************/

public class TempVoiceManager {

    public boolean isRegistered(String channelID) {
        return Main.getDB().getResult("SELECT * FROM voice_tempChannels WHERE channelID=?", channelID).getRowCount() == 1;
    }

    public boolean isRegistered(VoiceChannel channel) {
        return isRegistered(channel.getId());
    }

    public void register(String guildID, String channelID) {
        if (isRegistered(channelID)) return;
        Main.getDB().update("INSERT INTO voice_tempChannels (guildID, channelID) VALUES (?, ?)", guildID, channelID);
    }

    public void register(Guild guild, VoiceChannel channel) {
        register(guild.getId(), channel.getId());
    }


    public void unregister(String channelID) {
        if (!isRegistered(channelID)) return;
        Main.getDB().update("DELETE FROM voice_tempChannels WHERE channelID=?", channelID);
    }
    public void unregister(VoiceChannel channel) {
        unregister(channel.getId());
    }




}
