package xyz.sheepstar.wrapper.modules.voice.api;

import net.dv8tion.jda.api.entities.Category;
import net.dv8tion.jda.api.entities.Guild;
import net.dv8tion.jda.api.entities.VoiceChannel;
import xyz.sheepstar.wrapper.core.Main;

/********************************
 * @author Mathias Wagner
 * Created 25.01.2021
 ********************************/

public class VoiceManager {
    
    public String getChannelName(VoiceChannel channel) {
        return Main.getDB().getResult("SELECT * FROM voice_channels WHERE channelID=?", channel.getId()).getString("channelName");
    }

    public boolean isRegistered(VoiceChannel channel) {
        return Main.getDB().getResult("SELECT * FROM voice_channels WHERE channelID=?", channel.getId()).getRowCount() == 1;
    }

    public void register(Guild guild, VoiceChannel channel) {
        if (isRegistered(channel)) return;
        Main.getDB().update("INSERT INTO voice_channels (guildID, channelID) VALUES (?, ?)", guild.getId(), channel.getId());
    }

    public void unregister(Guild guild, VoiceChannel channel) {
        if (!isRegistered(channel)) return;
        Main.getDB().update("DELETE FROM voice_channels WHERE guildID=? AND channelID=?", guild.getId(), channel.getId());
    }

}
