package xyz.sheepstar.wrapper.modules.voice.commands;

import net.dv8tion.jda.api.events.message.guild.GuildMessageReceivedEvent;
import xyz.sheepstar.wrapper.modules.voice.api.Manager;
import xyz.sheepstar.wrapper.modules.voice.api.VoiceManager;
import xyz.sheepstar.wrapper.util.api.command.GuildCommand;
import xyz.sheepstar.wrapper.util.api.permission.PermissionNode;

import java.util.Arrays;
import java.util.List;

/********************************
 * @author Mathias Wagner
 * Created 25.01.2021
 ********************************/

public class SetupCommand extends GuildCommand {

    private VoiceManager voiceManager = Manager.getVoiceManager();

    @Override
    public List<String> getAlias() {
        return Arrays.asList("setup", "generate");
    }

    @Override
    public PermissionNode getPermission() {
        return PermissionNode.ADMINISTRATOR;
    }

    @Override
    public void executeCommand(String[] args, GuildMessageReceivedEvent e) {
        e.getGuild().createCategory("Sheepstar Voice").queue(cat -> {
            cat.createVoiceChannel("Click to create").queue(channel -> {
                voiceManager.register(e.getGuild(), channel);
            });
        });
        sendMessage()
                .setTitle("Tempchannel created")
                .setDescription("Modify it by using s!help or by going in the [Dashboard](https://sheepstar.xyz/dashboard)")
                .send(e.getChannel());
    }
}
