package xyz.sheepstar.wrapper.util;

import org.json.simple.JSONObject;
import org.json.simple.parser.JSONParser;

import java.io.*;

/********************************
 * @author Mathias Wagner
 * Created 22.01.2021
 ********************************/

public class Config {

    private File configFile;

    public Config(String fileName) {
        File tempFile = new File(fileName);
        if (tempFile.exists()) {
            try { this.configFile = tempFile; } catch (Exception ignored) { }
        } else System.exit(0);
    }

    public void update(String str, Object obj) {
        JSONObject jsonObject = new JSONObject();
        // Get old configuration
        JSONParser parser = new JSONParser();
        try (Reader reader = new FileReader(configFile.getAbsolutePath())) {
            JSONObject jsonObject2 = (JSONObject) parser.parse(reader);
            jsonObject2.forEach(jsonObject::put);
        } catch (Exception ignored) {  }

        // Updat new
        jsonObject.put(str, obj);
        try (FileWriter file = new FileWriter(configFile.getAbsolutePath())) { file.write(jsonObject.toJSONString()); } catch (IOException e) { }
    }

    public Object get(String path) {
        JSONParser parser = new JSONParser();
        try (Reader reader = new FileReader(configFile.getAbsolutePath())) {
            JSONObject jsonObject = (JSONObject) parser.parse(reader);
            return jsonObject.get(path);
        } catch (Exception ignored) { ignored.printStackTrace(); }
        return null;
    }

    public String getString(String path) {
        return (String) get(path);
    }

    public int getInteger(String path) {
        return (int) get(path);
    }

}
