package xyz.sheepstar.wrapper.util.api;

import net.dv8tion.jda.api.entities.Guild;
import xyz.sheepstar.wrapper.core.Main;

/********************************
 * @author Mathias Wagner
 * Created 24.01.2021
 ********************************/

public class GuildManager {

    private void updateString(Guild guild, String column, String newContent) {
        if (!isRegistered(guild)) register(guild);
        Main.getDB().update("UPDATE guilds SET ?=? WHERE guildID=?", column, newContent, guild.getId());
    }

    private String getString(Guild guild, String column) {
        if (!isRegistered(guild)) register(guild);
        return Main.getDB().getResult("SELECT * FROM guilds WHERE guildID=?", guild.getId()).getString(column);
    }

    public boolean isRegistered(Guild guild) {
        return Main.getDB().getResult("SELECT * FROM guilds WHERE guildID=?", guild.getId()).getRowCount() == 1;
    }

    public void register(Guild guild) {
        if (isRegistered(guild)) return;
        Main.getDB().update("INSERT INTO guilds (guildID, prefix, language, hasPremium, isBanned)" +
                                  " VALUES (?, ?, ?, ?, ?)", guild.getId(), "s!", "EN", "false", "false");
    }

    public String getLanguage(Guild guild) {
        return getString(guild, "language").toUpperCase();
    }

    public void updateLanguage(Guild guild, String newLanguage) {
        updateString(guild, "language", newLanguage.toUpperCase());
    }

    public String getPrefix(Guild guild) {
        return getString(guild, "prefix");
    }

    public void updatePrefix(Guild guild, String newLanguage) {
        updateString(guild, "prefix", newLanguage);
    }

    public boolean hasPremium(Guild guild) {
        return Boolean.parseBoolean(getString(guild, "hasPremium"));
    }

    public void setPremium(Guild guild, String premiumValue) {
        updateString(guild, "hasPremium", premiumValue);
    }

    public boolean isBanned(Guild guild) {
        return Boolean.parseBoolean(getString(guild, "isBanned"));
    }

    public void setBanned(Guild guild, String banValue) {
        updateString(guild, "isBanned", banValue);
    }

}
