package xyz.sheepstar.wrapper.util.api.economy;

import net.dv8tion.jda.api.entities.Guild;
import xyz.sheepstar.wrapper.core.Main;

/********************************
 * @author Mathias Wagner
 * Created 13.02.2021
 ********************************/

public class EconomyManager {

    public boolean isRegistered(Guild guild) {
        return Main.getDB().getResult("SELECT * FROM guild_economy WHERE guildID=?", guild.getId()).getRowCount() == 1;
    }

    public void register(Guild guild) {
        if (isRegistered(guild)) return;
        Main.getDB().update("INSERT INTO guild_economy (guildID, money) VALUES (?, '100')", guild.getId());
    }

    public void increase(Guild guild, String addMoney) {
        if (!isRegistered(guild)) register(guild);
        Main.getDB().update("UPDATE guild_economy SET money=money+? WHERE guildID=?", addMoney, guild.getId());
    }

    public void decrease(Guild guild, String removeMoney) {
        if (!isRegistered(guild)) register(guild);
        Main.getDB().update("UPDATE guild_economy SET money=money-? WHERE guildID=?", removeMoney, guild.getId());
    }

    public void set(Guild guild, String newMoney) {
        if (!isRegistered(guild)) register(guild);
        Main.getDB().update("UPDATE guild_economy SET money=? WHERE guildID=?", newMoney, guild.getId());
    }

    public String get(Guild guild) {
        if (!isRegistered(guild)) register(guild);
        return Main.getDB().getResult("SELECT * FROM guild_economy WHERE guildID=?", guild.getId()).getString("money");
    }

    public long getLong(Guild guild) {
        if (!isRegistered(guild)) register(guild);
        return Long.parseLong(get(guild));
    }
}
