package xyz.sheepstar.wrapper.util.api.economy;

import net.dv8tion.jda.api.entities.Guild;
import xyz.sheepstar.wrapper.util.api.sql.StorageMedium;

/********************************
 * @author Mathias Wagner
 * Created 13.02.2021
 ********************************/

public class ShopManager {

    private EconomyManager em;
    private Guild guild;
    private StorageMedium sm;

    public ShopManager(EconomyManager em, Guild guild) {
        this.em = em;
        this.guild = guild;
        this.sm = new StorageMedium(guild, "purchased_items");
    }

    public void buyItem(String price, String itemName, boolean checkAlready) {
        if (checkAlready && hasItem(itemName)) return;

        if (Integer.parseInt(em.get(guild)) >= Integer.parseInt(price)) {
//            if (item.equals("premium")) { Main.getGlobalManager().setPremium(guild);return; }
            sm.inUpdate(itemName, String.valueOf(getItemCount(itemName)+1));
            em.decrease(guild, price);
        }
    }

    public boolean hasItem(String itemName) {
        return sm.exists(itemName);
    }

    public int getItemCount(String itemName) {
        return Integer.parseInt(String.valueOf(sm.getValue(itemName)));
    }

}
