package xyz.sheepstar.wrapper.util.api.module;

import net.dv8tion.jda.api.entities.Guild;
import xyz.sheepstar.wrapper.core.Main;

/********************************
 * @author Mathias Wagner
 * Created 24.01.2021
 ********************************/

public class ModuleManager {

    public boolean isEnabled(String guildID, String module) {
        return Main.getDB()
                .getResult("SELECT * FROM enabled_modules WHERE guildID=? AND name=?", guildID, module)
                .getRowCount() == 1;
    }

    public boolean isEnabled(Guild guild, String module) {
        return isEnabled(guild.getId(), module);
    }

    public boolean exists(String module) {
        return Main.getDB().getResult("SELECT * FROM existing_modules WHERE name=?", module).getRowCount() == 1;
    }

    public boolean usedWhereOther(Guild guild, String prefix) {
        return Main.getDB().getResult("SELECT * FROM enabled_modules WHERE guildiD=? AND prefix=?", guild.getId(), prefix)
                .getRowCount() == 1;
    }

    public void disable(Guild guild, String module) {
        if (!isEnabled(guild, module)) return;
        Main.getDB().update("DELETE FROM enabled_modules WHERE name=? AND guildID=?", module, guild.getId());
    }

    public void enable(Guild guild, String module, String prefix) {
        if (isEnabled(guild, module)) return;
        Main.getDB().update("INSERT INTO enabled_modules (name, guildID, prefix) VALUES (?, ?, ?)", module, guild.getId(), prefix);
    }

    public String getPrefix(Guild guild, String module) {
        if (!isEnabled(guild, module)) return "";
        return Main.getDB().getResult("SELECT * FROM enabled_modules WHERE guildID=? AND name=?", guild.getId(), module).getString("prefix");
    }

}
